#include "calculator.h"


//!!! Отформатируйте код. Что с отступами делается?


//!!! Что тут за глобальные переменные??

Calculator::Calculator (QWidget *parent) : QWidget(parent), func2 (false)

{
         Calculator_create();
}


void Calculator::Calculator_create()
{

    grid  = new QGridLayout( this );

    button = new QPushButton("AC",this);

     lcd  = (new QLCDNumber(this));

        this->resize(600,600);

        this->setWindowTitle("Обычный калькулятор");

         lcd->setDigitCount(20);

         lcd->setMinimumSize(QSize(700,100));

         lcd->setSegmentStyle(QLCDNumber::Flat);

        grid->addWidget(lcd,0,0,1,5);

        vec_r.push_back( new QRadioButton("Обычный калькулятор",this));

        vec_r.push_back( new QRadioButton("Инженерный калькулятор", this));

        for(auto but : vec_r)
        {
            but->setCheckable(true);
        }

        vec_r[0]->setChecked(true);

        vec_r[1]->setChecked(false);

        QVBoxLayout * vbox = new QVBoxLayout();

        for(auto r_btn : vec_r)
        {
           vbox->addWidget(r_btn);
        }

        grid->addLayout(vbox,1,0,1,4);

        button->setSizePolicy(QSizePolicy::Expanding,QSizePolicy::Expanding);

        grid->addWidget(button,1,4);


         but_text = {"7","8","9","/","sqrt","4","5","6", "*", "1/x","1","2","3","-","=","0",".","+"};


         for(auto b_txt : but_text)
         {
             vec_but.push_back(new QPushButton(b_txt,this));
         }


         for(auto but : vec_but)
         {
             but->setSizePolicy(QSizePolicy::Expanding,QSizePolicy::Expanding);


         }


         int line = 4;

         int column = 5;


         for(int i =0 ; i < line - 1 ; i ++)
         {
             for(int j =0 ; j < column  ; j++)
             {


                 if (vec_but[i*column + j]->text() == "=")
                 {
                        grid->addWidget(vec_but[i*column + j],i+2,j,2,1);
                 }

                 else
                 {
                        grid->addWidget(vec_but[i*column + j],i+2,j);
                 }

             }
         }

         for(int j =0 ; j < column - 2 ;j++)
         {

            if(vec_but[(line-1)*column + j]->text() == "0")
             {
                  grid->addWidget(vec_but[(line-1)*column + j],line-1 +2,j,1,2);
             }

             else
             {
                    grid->addWidget(vec_but[(line-1)*column + j],line-1+2,j+1);
             }

         }

         for(auto but : vec_but)
            {
                if(
                   but->text() == "0" ||
                   but->text() == "1" ||
                   but->text() == "2" ||
                   but->text() == "3" ||
                   but->text() == "4" ||
                   but->text() == "5" ||
                   but->text() == "6" ||
                   but->text() == "7" ||
                   but->text() == "8" ||
                   but->text() == "9"
                   )
                {
                    connect(but,&QPushButton::clicked,this,&Calculator::button_number);
                }

                 else if(but->text() ==  "=")
                {
                    connect(but,&QPushButton::clicked,this,&Calculator::button_same);
                }

                else if(but->text() == ".")
                {
                    connect(but,&QPushButton::clicked,this,&Calculator::button_point);
         }

                  else  if (
                            but->text() == "+" ||
                            but->text() == "-" ||
                            but->text() == "*" ||
                            but->text() == "/"
                      )
                    {
                        connect (but,&QPushButton::clicked,this,&Calculator::button_operation);
                    }

                    else if (
                            but->text() == "1/x"
                            || but->text() == "sqrt"

                      )
                    {
                        connect(but,&QPushButton::clicked,this,&Calculator::math_func);
                    }

                }


                 connect(button,&QPushButton::clicked,this,&Calculator::delete_button);

                 connect(vec_r[0],&QRadioButton::clicked,this, &Calculator::calculator_types );

                 connect(vec_r[1],&QRadioButton::clicked,this, &Calculator::calculator_types );

}

 void Calculator::Calculator_create_eng()
 {
         grid =new QGridLayout(this);

          this->resize(1200,800);

         this->setWindowTitle("Инженерный калькулятор");

          lcd = new QLCDNumber(this);

          lcd->setDigitCount(40);

          lcd->setMinimumSize(QSize(1000,100));

          lcd->setSegmentStyle(QLCDNumber::Flat);

        grid->addWidget(lcd,0,0,1,9);

         QVBoxLayout * vbox = new QVBoxLayout();

         for(auto but : vec_r)
         {
            vbox->addWidget(but);
         }

         grid->addLayout(vbox,1,0,1,8);

         button = new QPushButton (this);

         button->setText("AC");

         button->setSizePolicy(QSizePolicy::Expanding,QSizePolicy::Expanding);

         grid->addWidget(button,1,8);

         for (auto b_txt : but_text)
         {
             vec_but.push_back(new QPushButton(b_txt,this));
         }

         for (auto but : vec_but )
         {
             but->setSizePolicy(QSizePolicy::Expanding,QSizePolicy::Expanding);

         }

          int line = 4;

          int column = 5;

          for(int i =0 ; i < line - 1 ; i ++)
          {
              for(int j =0 ; j < column  ; j++)
              {


                  if (vec_but[i*column + j]->text() == "=")
                  {
                         grid->addWidget(vec_but[i*column + j],i+2,j+4,2,1);
                  }

                  else
                  {
                         grid->addWidget(vec_but[i*column + j],i+2,j+4);
                  }

              }
          }

          for(int j =0 ; j < column - 2 ;j++)
          {

             if (vec_but[(line-1)*column + j]->text() == "0")
              {
                  grid->addWidget(vec_but[(line-1)*column + j],line-1 +2,j+4,1,2);
              }

              else
              {
                     grid->addWidget(vec_but[(line-1)*column + j],line-1+2,j+5);
              }

          }

          but_text2 ={ "sinh","sin","exp","x^2","cosh","cos","ln","x^3","tanh","tan","log","x^y","n!","pi","x^(1/3)","x^(1/y)"};


          for(auto b_txt : but_text2)
          {
              vec_but2.push_back(new QPushButton(b_txt,this));
          }


          for(auto but : vec_but2)
          {
              but->setSizePolicy(QSizePolicy::Expanding,QSizePolicy::Expanding);

          }
           int line2 = 4;

           int column2 = 4;

           for(int i = 0 ; i < line2 ; i++)
           {
               for( int j =0 ; j < column2 ; j++)
               {
                  grid->addWidget(vec_but2[i*column2 +j],i+2,j);
               }
           }


           for(auto but : vec_but)
              {
                  if
                     (
                     but->text() == "0" ||
                     but->text() == "1" ||
                     but->text() == "2" ||
                     but->text() == "3" ||
                     but->text() == "4" ||
                     but->text() == "5" ||
                     but->text() == "6" ||
                     but->text() == "7" ||
                     but->text() == "8" ||
                     but->text() == "9"
                     )
                  {
                      connect(but,&QPushButton::clicked,this,&Calculator::button_number);
                  }

                  else if (but->text() ==  "=")
                  {
                      connect(but,&QPushButton::clicked,this,&Calculator::button_same);
                  }

                  else if (but->text() == ".")
                  {
                      connect(but,&QPushButton::clicked,this,&Calculator::button_point);
           }

                      else if
                        (
                              but->text() == "+" ||
                              but->text() == "-" ||
                              but->text() == "*" ||
                              but->text() == "/"
                        )
                      {
                          connect(but,&QPushButton::clicked,this,&Calculator::button_operation);
                      }

                      else if
                          (
                              but->text() == "1/x"
                            || but->text() == "sqrt"

                          )
                      {
                          connect(but,&QPushButton::clicked,this,&Calculator::math_func);
                      }

                  }
           for(auto but : vec_but2)
           {
               if
                       (
                                          but->text() == "sin"
                                       || but->text() == "cos"
                                       || but->text() == "tan"
                                       || but->text() == "sinh"
                                       || but->text() == "cosh"
                                       || but->text() == "tanh"
                                       || but->text() == "exp"
                                       || but->text() == "ln"
                                       || but->text() == "x^2"
                                       || but->text() == "x^3"
                                       || but->text() == "x^(1/3)"
                                       || but->text() == "n!"
                        )
               {
                   connect(but,&QPushButton::clicked,this,&Calculator::math_func);
               }

               else if (but->text() == "pi")
               {
                    connect(but,&QPushButton::clicked,this,&Calculator::button_pi);
               }

               else if (but->text() == "log"
                  || but->text() == "x^y"
                  || but->text() == "x^(1/y)"
                  )
              {
                   connect(but,&QPushButton::clicked,this,&Calculator::math_func2);
              }

           }

           connect(button,&QPushButton::clicked,this,&Calculator::delete_button);

           return;
 }

void Calculator::calculator_types()
{
    QRadioButton * lcd = qobject_cast<QRadioButton*>(sender());

    if (lcd == nullptr)
    {
        Calculator::delete_button();
        return ;
    }

   if ( lcd->text() == QString("Инженерный калькулятор") )
   {

       delete_ordinary_calculator();

       Calculator_create_eng();

   }


   if(lcd->text() == QString("Обычный калькулятор") )
 {

       delete_engineer_calculator();

       Calculator_create();

          return;
   }




}

void Calculator::button_number()
{

    QPushButton * but =qobject_cast<QPushButton *>(sender());

    if (but == nullptr)
    {
        Calculator::delete_button();
        return ;
    }

    if (lcd->value() == 0 && !lcd->smallDecimalPoint())
    {
    lcd->display( but->text());
    }

    else
    {
        if (lcd->smallDecimalPoint() && !QString::number(lcd->value()).contains('.'))
        {
        lcd->display(QString::number(lcd->value()) +"." + but->text());
        }

           else
        {
        lcd->display(QString::number(lcd->value()) + but->text());
        }
    }

}


void Calculator::button_operation()
{

    if (func2 && lcd->digitCount() != 0)
    {
        double result ;

        if (func_2 == "log")
        {
            double x = vec_dl.back();

            double y = lcd->value();

            if( y < 0 )
            {
                QMessageBox * error = new QMessageBox(this);

                error->warning(this,"Error","Нельзя делить на 0");

                delete_button();
            }

             result = log(y) / log( x );

        }

        else if (func_2 == "x^y")
        {
            double x = vec_dl.back();

            double y = lcd->value();

             result = pow(x,y);

        }

      else
       {
           double x = vec_dl.back();

           double y = lcd->value();

            result = pow(x,1.0/y);

       }

       vec_dl.pop_back();

       vec_dl.push_back(result);


         QPushButton * but = qobject_cast<QPushButton*>(sender());

         if (but == nullptr)
         {
             Calculator::delete_button();
             return ;
         }

         vec_s.push_back(but->text());

         lcd->display("");

         lcd->setSmallDecimalPoint(false);

         func2 = false;

         return;

    }



    if (vec_dl.size() > vec_s.size())
    {
        QPushButton * but = qobject_cast<QPushButton*>(sender());

        if (but == nullptr)
        {
            Calculator::delete_button();
            return ;
        }

        vec_s.push_back(but->text());

        lcd->setSmallDecimalPoint(false);

        return;
    }


    if (lcd->digitCount() != 0 )
    {

    QPushButton * but = qobject_cast<QPushButton*>(sender());

    if (but == nullptr)
    {
        Calculator::delete_button();
        return ;
    }

    vec_dl.push_back(lcd->value());

    vec_s.push_back(but->text());

    lcd->display(" ");

    lcd->setSmallDecimalPoint(false);

    return;

    }

}

void Calculator::delete_button()
{
    lcd->display(" ");

    lcd->setSmallDecimalPoint(false);

    func2 = false;

    vec_dl.clear();

    vec_s.clear();

    func_2 = " ";

}


void Calculator::button_point()
{
  if (!lcd->smallDecimalPoint() && lcd->value() != cosh(-1) && !QString::number(lcd->value()).contains('.'))
  {
      lcd->setSmallDecimalPoint(true);

      lcd->display(QString::number(lcd->value()) + ".");
  }


}

void Calculator::button_same()
{

    if (func2 && lcd->digitCount() != 0)
    {
        double result ;

        if (func_2 == "log")
        {
            double x = vec_dl.back();

            double y = lcd->value();

            if( y < 0 )
            {
                QMessageBox * error = new QMessageBox(this);

                error->warning(this,"Error","Невозможно разделить на 0");

                delete_button();
            }

             result = log(y) / log( x );

        }

        if (func_2 == "x^y")
        {
            double x = vec_dl.back();

            double y = lcd->value();

             result = pow(x,y);

        }

       if (func_2 == "x^(1/y)" )
       {
           double x = vec_dl.back();

           double y = lcd->value();

            result = pow(x,1.0/y);

       }

        vec_dl.pop_back();

        vec_dl.push_back(result);


         lcd->setSmallDecimalPoint(false);

         func2 = false;

         double result1 = count_pars(vec_dl,vec_s);

         lcd->display(result1);

         vec_dl.clear();

         vec_s.clear();

         return;


    }

    if (lcd->digitCount() == 0 && vec_dl.size() == 1)
    {
        lcd->display(vec_dl[0]);

        return;

    }


    if (lcd->digitCount() != 0)
    {

  vec_dl.push_back(lcd->value());

  double result = count_pars(vec_dl,vec_s);

  lcd->display(result);

  vec_dl.clear();

  vec_s.clear();

  return;

    }

}

//!!! Почему объекты передаются по значению?
double Calculator::count_pars(QVector<double> &numbers, QVector<QString> &operations)
{

    if (numbers.size() == 1)

        return numbers[0];

    for(QVector<QString>::Iterator operat = operations.begin() ; operat != operations.end() ; )
    {
        if (*operat == "*" || *operat == "/")
        {
            int ind = operat - operations.begin() ;

            double cur = 0;

           if (*operat == "*")
           {
               cur = numbers[ind]*numbers[ind+1];
           }

           else
           {
               if(numbers[ind+1] == 0)
               {
                   QMessageBox * error = new QMessageBox(this);

                   error->warning(this,"Error","Нельзя делить на 0");

                   delete_button();
               }

               cur = numbers[ind]/numbers[ind+1];
           }

           operat =  operations.erase(operat);

           numbers[ind]= cur;

           QVector<double>::iterator iter_del  = numbers.begin();

           iter_del=iter_del+ind+1;

           numbers.erase(iter_del);

        }
        else
         {
            ++operat;
         }

    }

    for(QVector<QString>::Iterator operat = operations.begin() ; operat != operations.end() ; )
    {
       int ind = 0;

        double cur = 0;

       if(*operat == "+")
       {
           cur = numbers[ind] + numbers[ind+1];
       }

       else
       {
           cur = numbers[ind] - numbers[ind+1];
       }

     operat =  operations.erase(operat);

     numbers[ind]= cur;

     QVector<double>::iterator iter_del  = numbers.begin();

     iter_del=iter_del+ind+1;

     numbers.erase(iter_del);

    }

    return numbers[0];

}

 void Calculator::math_func()
 {
     if (lcd->digitCount() != 0)
     {
      vec_dl.push_back(lcd->value());

     double elem = count_pars(vec_dl,vec_s);

     vec_dl.clear();

     vec_s.clear();

      QPushButton * but =qobject_cast<QPushButton *>(sender());

      if (but == nullptr)
      {
          Calculator::delete_button();
          return ;
      }

      if (but->text() == "sqrt")
      {
          if (elem < 0)
          {
              QMessageBox * error = new QMessageBox(this);

              error->warning(this,"Error","Нельзя брать корень от отрицательного числа");

              delete_button();
          }
          else
          elem = sqrt(elem);
      }

      if (but->text() == "1/x")
      {

          if (elem == 0)
          {
              QMessageBox * error = new QMessageBox(this);

              error->warning(this,"Error","Нельзя делить на 0");

              delete_button();
          }
        else
          elem = 1/elem;
      }


      if (but->text() == "sin")
      {
          elem = sin(elem);
      }

      if (but->text() == "cos")
      {
          elem = cos(elem);
      }

      if (but->text() == "tan")
      {

          elem = tan(elem);
      }

      if (but->text() == "sinh")
      {
              elem = sinh(elem);
      }

      if (but->text() == "cosh")
      {
              elem = cosh(elem);
      }

      if (but->text() == "tanh")
      {
          elem = tanh(elem);
      }

      if (but->text() == "ln")
      {
          if (elem < 0)
          {
              QMessageBox * error = new QMessageBox(this);

              error->warning(this,"Error","Область определения ln [ 0 ; +inf ] ");

              delete_button();
          }
         else
              elem = log(elem);
      }

      if (but->text() == "exp")
      {
          elem = exp(elem);
      }

      if (but->text() == "x^2")
      {
          elem= pow(elem,2);
      }

      if (but->text() == "x^3")
      {
            elem = pow(elem,3);
      }

      if (but->text() == "x^(1/3)")
      {
            elem = pow(elem,1.0/3.0);
      }

      if (but->text() == "n!")
      {
          int cur = 1;
          for(int i = 1 ; i <= elem ; i++ )
             cur*=i;
             elem = cur;

      }

      vec_dl.push_back(elem);

      lcd->display("");

     }
 }

 void Calculator::button_pi()
 {
     if (lcd->digitCount() == 0  || lcd->value() == 0)
     {
         double cur = acos(-1);
         lcd->display(cur);
     }

 }


 void Calculator::math_func2()
 {
     if (lcd->digitCount() != 0)
     {
         QPushButton *but = qobject_cast< QPushButton *>(sender());

         if (but == nullptr)
         {
             Calculator::delete_button();
             return ;
         }

         if (but->text() =="log")
         {
                 if (lcd->value() == 1 || lcd->value() < 0)
                 {
                     QMessageBox * error = new QMessageBox(this);

                     error->warning(this,"Error","Основание логарифма должно быть больше 0 и не равно 1");

                     delete_button();
                 }
         }

     vec_dl.push_back(lcd->value());

     func_2 = (but->text());

     lcd->display(" ");

     func2 = true;

     lcd->setSmallDecimalPoint(false);



     }
 }


  void Calculator::delete_ordinary_calculator()
  {
      QLayoutItem * it = grid->itemAtPosition(0,0);

      QWidget * widg = it->widget();

      if (widg)
      {
          grid->removeWidget(widg);

          delete widg;

      }


      it = grid->itemAtPosition(1,4);

      widg = it->widget();

     if(widg)
      {
          grid->removeWidget(widg);

          delete widg;
      }

      for( int i = 0 ; i < 3 ; i++  )
      {
          for ( int j = 0 ; j < 5 ; j++)
          {
              it = grid->itemAtPosition(i +2 ,j);

              widg = it->widget();

              if (widg)
              {
                  grid->removeWidget(widg);

                  delete widg;
              }
          }
      }

      for ( int j = 0 ; j < 4 ; j++)
      {
          if (j != 1)
          {

          it = grid->itemAtPosition(5 ,j);

          widg = it->widget();

          if (widg)
          {
              grid->removeWidget(widg);

              delete widg;
          }
          }
       }

      vec_but.clear();

      vec_r.clear();

      delete grid;
  }

  void Calculator::delete_engineer_calculator()
  {
      QLayoutItem * it = grid->itemAtPosition(0,0);

            QWidget * widg = it->widget();

           if (widg)
            {
                grid->removeWidget(widg);

                delete widg;

            }

            it = grid->itemAtPosition(1,8);

            widg = it->widget();

            if (widg)
            {
                grid->removeWidget(widg);

                delete widg;
            }

            for( int i = 0 ; i < 3 ; i++  )
            {
                for ( int j = 0 ; j < 9 ; j++)
                {
                    it = grid->itemAtPosition(i +2 ,j);

                    widg = it->widget();

                    if (widg)
                    {
                        grid->removeWidget(widg);

                        delete widg;
                    }
                }
            }

            for(int j = 0 ; j < 5 ; j++)
            {

                it = grid->itemAtPosition(5 ,j);

                widg = it->widget();

                if (widg)
                {
                    grid->removeWidget(widg);

                    delete widg;
                }
            }

            for(int j = 6 ; j < 8 ; j++)
            {
                it = grid->itemAtPosition(5 ,j);

                widg = it->widget();

                if (widg)
                {
                    grid->removeWidget(widg);

                    delete widg;
                }
            }

            vec_but.clear();

            vec_but2.clear();

            vec_r.clear();

           delete grid;
  }

 Calculator::~Calculator() {}










