#ifndef calculator_H
#define calculator_H

#include <QMainWindow>
#include<QObject>
#include<QWidget>
#include<QBoxLayout>
#include<QPushButton>
#include<QtMath>
#include<QRadioButton>
#include<QLCDNumber>
#include<QPalette>
#include<QTypeInfo>
#include<QtAlgorithms>
#include<QMessageBox>
#include<QSize>
#include<QSpacerItem>
#include<QLayoutItem>


class Calculator : public QWidget
{
    Q_OBJECT

protected:

    QVector<double> vec_dl;

    QVector<QString> vec_s;

    QVector<QPushButton*> vec_but;

     QVector<QPushButton*> vec_but2;

    QVector<QString> but_text;

    QVector<QString> but_text2;

    QVector<QRadioButton *> vec_r;

    QString func_2;

    bool func2;

    QLCDNumber* lcd;

    QPushButton *button;

    QGridLayout * grid;

  void Calculator_create();

  void Calculator_create_eng();

  void delete_ordinary_calculator();

  void delete_engineer_calculator();

  double count_pars(QVector<double> &numbers, QVector<QString> &operations);

public:
    Calculator(QWidget *parent = nullptr);

    ~Calculator();

protected slots:

    void button_number();

    void button_operation();

    void delete_button();

    void button_point();

    void button_same();

    void math_func();

    void button_pi();

    void math_func2();

    void calculator_types();


};

#endif
